---
title: Common
slug: backyardapi/home-improvement-product-data-api/parameters/common
docTags: 
createdAt: 2024-07-23T14:57:52.062Z
---

# Common Parameters

<font color="#52c41a">`GET`  </font>`/request`

The following parameters are used to configure your request to the Home Improvement Product Data API. They should be appended as querystring parameters to a  `GET` HTTP request to the  `/request`  endpoint.

For example, to request search results, for the search term  `highlighter pens` , sorted by  `best_seller` , on  `homedepot.com`  the request would be:

:::CodeblockTabs
HTTP

```HTTP
https://api.backyardapi.com/request?api_key=demo&engine=homedepot&type=search&search_term=lawn+mower&sort_by=best_seller
```

```curl
curl -L --get https://api.backyardapi.com/request
-d api_key="demo"
-d engine="homedepot"
-d type="search"
-d search_term="lawn mower"
-d sort_by="best_seller"
```

```nodejs
const axios = require('axios');

// set up the request parameters
const params = {
  api_key: "demo",
  engine: "homedepot",
  type: "search",
  search_term: "lawn mower",
  sort_by: "best_seller"
}

// make the http GET request to Backyard API
axios.get('https://api.backyardapi.com/request', { params })
  .then(response => {

    // print the JSON response from Backyard API
    console.log(JSON.stringify(response.data, 0, 2));

  }).catch(error => {
    // catch and print the error
    console.log(error);
  })
```

```python
import requests
import json

# set up the request parameters
params = {
  'api_key': 'demo',
  'engine': 'homedepot',
  'type': 'search',
  'search_term': 'lawn mower',
  'sort_by': 'best_seller'
}

# make the http GET request to Backyard API
api_result = requests.get('https://api.backyardapi.com/request', params)

# print the JSON response from Backyard API
print(json.dumps(api_result.json()))
```

```php
<?php
      
# set up the request parameters
$queryString = http_build_query([
  'api_key' => 'demo',
  'engine': 'homedepot',
  'type': 'search',
  'search_term': 'lawn mower',
  'sort_by': 'best_seller'
]);

# make the http GET request to Backyard API
$ch = curl_init(sprintf('%s?%s', 'https://api.backyardapi.com/request', $queryString));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
# the following options are required if you're using an outdated OpenSSL version
# more details: https://www.openssl.org/blog/blog/2021/09/13/LetsEncryptRootCertExpire/
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_TIMEOUT, 180);

$api_result = curl_exec($ch);
curl_close($ch);

# print the JSON response from Backyard API
echo $api_result;

?>
```
:::

:::hint{type="info"}
**Request-Specific Parameters**
Additional parameters are available depending on the type of request being made (as-determined by the  `type`  parameter). For example, if you make a request with  `type=reviews`  then additional [Reviews Parameters](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/reviews), specific to  `reviews`  requests, are available.
:::

***

### Common Parameters

The following common parameters are required for all requests to the Home Improvement Product Data API.

| `Parameter`        | `Required` | `Description`                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| ------------------ | ---------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `api_key`          | `required` | The API key for your Backyard API account.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| `engine`           | `required` | The engine of Home Improvement data to retrieve, for example `homedepot`                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| `type`             | `required` | The type of Home Improvement data to retrieve. The value of the `type` parameter determines which additional parameters are available. For example, if you make a request with `type=search` then additional [Search Parameters ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/search), specific to `search` requests, are available.  <br />Valid values for `type` are:<br />1) `search`
2) Request search results for a `search_term` or Home Improvement search results page `url` . See additional [Search Parameters ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/search).<br /><br />1) `category`
2) Request category-listing results for a `category_id` or Home Improvement search results page `url` . See additional [Category Parameters ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/category).<br /><br />1) `product`
2) Request data from a Home Improvement product page via an `item_id` or Home Improvement product page `url` . See additional [Product Parameters ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/product).<br /><br />1) `reviews`
2) Request customer reviews for an `item_id` or Home Improvement product page `url` . See additional [Reviews Parameters ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/reviews).<br /><br />1) `questions`
2) Request customer questions & answers for an `item_id` or Home Improvement product page `url` . See additional [Questions Parameters ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/questions). |
| `customer_zipcode` | `optional` | Determines the specific customer zipcode location of the request. This is useful to see in-store pricing for a particular location.  <br />To use the `customer_zipcode` parameter you must first setup the zipcode in the [zipcodes section ](https://app.backyardapi.com/zipcodes)of the Dashboard.  <br />For more information please see the [Customer Zipcode Reference ](https://docs.trajectdata.com/backyardapi/zipcodes-api/overview).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| `output`           | `optional` | Determines the format in which results are returned. Can be set to `json` (default) to get the results as structured JSON, `html` to get the raw html retrieved or `csv` to return the results in CSV format. When using `csv` you can also use the `csv_fields` parameter to specify which fields to return in the CSV.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| `csv_fields`       | `optional` | Determines the fields that are returned when returning in `csv` mode (i.e. when the `output` parameter is set to `csv` ). Should be specified as a comma seperated list of fields (in nested field, dot notation, format). For more information on the `csv_fields` parameter please see the [CSV Fields Reference ](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/reference/csv-fields).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| `include_fields`   | `optional` | A comma-seperated list JSON field names to **include** in the JSON object the API returns. You can specify the field names in dot notation - i.e. `include_fields=pagination` will only include the the `pagination` property in the response JSON. Use `include_fields` if you only want to include specific fields in the API's JSON response.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| `exclude_fields`   | `optional` | A comma-seperated list of JSON field names to **exclude** from the JSON object the API returns. You can specify the field names in dot notation - i.e. `exclude_fields=pagination` will remove the `pagination` property from the response JSON. Use `exclude_fields` if there are specific fields you wish to exclude from the API's JSON response.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |

***

**Next Steps**
     [Search Parameters](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/search)
     [Category Parameters](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/category)
     [Product Parameters](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/product)
     [Reviews Parameters](https://docs.trajectdata.com/backyardapi/home-improvement-product-data-api/parameters/reviews)
